//Egg-shield building. (Shield buddy :D)

freeslot("MT_BUILDSHIELD","SPR_BSHD","SPR_BCOM","MT_BUILDGUARD")
freeslot("S_BUILDSHIELD", "S_BUILDSHIELD_STAY", "S_BGUARD_STND")
for i = 1,5
	freeslot("S_BGUARD_WALK"..i,"S_BGUARD_WALKBACK"..i)
end
states[S_BUILDSHIELD] = {SPR_BSHD,A,-1,nil,0,0,S_BUILDSHIELD} --The shield
states[S_BUILDSHIELD_STAY] = {SPR_NULL,A,2,nil,0,0,S_NULL}

states[S_BGUARD_STND] = {SPR_BCOM,A,2,nil,0,0,S_BGUARD_STND} --Guard guarding.

states[S_BGUARD_WALK1] = {SPR_BCOM,A,3,nil,0,0,S_BGUARD_WALK2} --Guard behaviour 1 / Attack mode.
states[S_BGUARD_WALK2] = {SPR_BCOM,B,3,nil,0,0,S_BGUARD_WALK3}
states[S_BGUARD_WALK3] = {SPR_BCOM,C,3,nil,0,0,S_BGUARD_WALK4}
states[S_BGUARD_WALK4] = {SPR_BCOM,D,3,nil,0,0,S_BGUARD_WALK5}
states[S_BGUARD_WALK5] = {SPR_BCOM,E,3,nil,0,0,S_BGUARD_WALK1}

states[S_BGUARD_WALKBACK1] = {SPR_BCOM,A,3,nil,0,0,S_BGUARD_WALKBACK2} --Guard behaviour 2
states[S_BGUARD_WALKBACK2] = {SPR_BCOM,E,3,nil,0,0,S_BGUARD_WALKBACK3}
states[S_BGUARD_WALKBACK3] = {SPR_BCOM,D,3,nil,0,0,S_BGUARD_WALKBACK4}
states[S_BGUARD_WALKBACK4] = {SPR_BCOM,C,3,nil,0,0,S_BGUARD_WALKBACK5}
states[S_BGUARD_WALKBACK5] = {SPR_BCOM,B,3,nil,0,0,S_BGUARD_WALKBACK1}

mobjinfo[MT_BUILDSHIELD] = {
	-1,              // doomednum
	S_BUILDSHIELD,   // spawnstate
	10,               // spawnhealth
	S_BUILDSHIELD,   // seestate
	sfx_None,        // seesound
	35,              // reactiontime
	sfx_s3k7b,       // attacksound
	S_BUILDSHIELD,   // painstate
	0,               // painchance
	sfx_s3k7b,       // painsound
	S_NULL,          // meleestate
	S_NULL,          // missilestate
	S_BUILDSHIELD_STAY,// deathstate
	S_NULL,          // xdeathstate
	sfx_wbreak,      // deathsound
	3,               // speed
	24*FRACUNIT,     // radius
	128*FRACUNIT,    // height
	1,               // display offset
	100,             // mass
	0,               // damage
	sfx_None,        // activesound
	MF_NOGRAVITY|MF_SHOOTABLE, // flags
	S_NULL           // raisestate
}
mobjinfo[MT_BUILDGUARD] = {
	-1,                // doomednum
	S_BGUARD_STND,     // spawnstate
	1,                 // spawnhealth
	S_BGUARD_WALK1,    // seestate
	sfx_None,          // seesound
	35,                // reactiontime
	sfx_None,          // attacksound
	S_BGUARD_WALKBACK1,// painstate
	0,                // painchance
	sfx_dmpain,       // painsound
	S_NULL, 		  // meleestate
	S_NULL,   		  // missilestate
	S_XPLD1,		  // deathstate
	S_TNTBARREL_EXPL1,// xdeathstate
	sfx_pop,          // deathsound
	6,                // speed
	16*FRACUNIT,      // radius
	48*FRACUNIT,      // height
	0,                // display offset
	100,              // mass
	0,                // damage
	sfx_None,         // activesound
	MF_SPECIAL|MF_SHOOTABLE,        // flags
	S_NULL            // raisestate
}
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.tracer and mo.tracer.valid
			mo.color = mo.tracer.color
		end
		local ax = P_ReturnThrustX(nil,mo.angle,mo.scale)
		local ay = P_ReturnThrustY(nil,mo.angle,mo.scale)
		if mo.shieldhealth
		and mo.health
			if not mo.sh
				mo.sh = P_SpawnMobjFromMobj(mo,ax,ay,0,MT_BUILDSHIELD)
				if mo.tracer and mo.tracer.valid
					mo.sh.tracer = mo.tracer
				else
					mo.sh.tracer = mo
				end
				mo.sh.target = mo
				mo.sh.color = mo.color
				mo.sh.angle = mo.angle
				mo.sh.scale = mo.scale/2*3
			end
		end
		if mo.health
			if R_PointToDist2(0,0,mo.momx,mo.momy) > FRACUNIT
				mo.angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
				if mo.state < S_BGUARD_WALK1
				or mo.state > S_BGUARD_WALK5
					mo.state = S_BGUARD_WALK1
				end
			elseif mo.state != S_BGUARD_STND
				mo.state = S_BGUARD_STND
			end
		end
		
		if mo.sh and mo.sh.valid
		and mo.sh.health
			mo.droprings = $ or 0
			mo.droppedr = $ or 0
			
			mo.droprings = $+1
			if mo.droprings >= TICRATE*10
			and mo.droppedr < 10
				mo.droprings = 0
				mo.droppedr = $+1
				
				S_StartSound(mo,sfx_antiri)
				P_SpawnMobjFromMobj(mo,0,0,mo.height,MT_SPARK)
				local fa = mo.angle+ANGLE_180
				local r = P_SpawnMobjFromMobj(mo,0,0,mo.height,MT_FLINGRING)
				r.fuse = TICRATE*8
				r.scale = mo.scale
				P_SetObjectMomZ(r,FRACUNIT*2)
				P_InstaThrust(r,fa,2*FRACUNIT)
			end
			if mo.droppedr and mo.droppedr >= 10
				if (leveltime%20) <= 4
					mo.colorized = true
				else
					mo.colorized = false
				end
			end
		
			mo.flags = $|MF_NOCLIPTHING
		
			local az = 0
			if P_MobjFlip(mo) == -1 az = mo.height end
			P_ChangeOrigin(mo.sh,mo.x+ax,mo.y+ay,mo.z+az,true)
			if mo.tracer and mo.tracer.valid
				mo.sh.tracer = mo.tracer
			else
				mo.sh.tracer = mo
			end
			mo.sh.target = mo
			mo.sh.momx = mo.momx
			mo.sh.momy = mo.momy
			mo.sh.momz = mo.momz
			mo.sh.scale = mo.scale/2*3
			mo.sh.angle = mo.angle
			
			mo.sh.stopthrust = $ or 0
			if mo.sh.stopthrust mo.sh.stopthrust = $-1 end
			
			mo.noballs = $ or 0
			if mo.noballs 
				mo.noballs = $-1
				mo.removeballs = true
				mo.sh.health = mo.shieldhealth
			elseif mo.removeballs
				mo.sh.flags2 = $&~MF2_FRET
				mo.removeballs = false
			end
			if mo.sh.health and mo.sh.health == 1
				if (leveltime%20) <= 4
					mo.sh.colorized = true
				else
					mo.sh.colorized = false
				end
			end
			local diff = abs((mo.sh.health)-mo.shieldhealth)
			if mo.sh.health
			and mo.shieldhealth != mo.sh.health
			and not mo.noballs
			and diff and diff <= mo.sh.health
				mo.sh.flags2 = $|MF2_FRET
				mo.noballs = 20
				mo.shieldhealth = mo.sh.health
				local g = P_SpawnGhostMobj(mo.sh) --Colorized flashing can be unnoticable
				g.fuse = 7
				g.colorized = true
				g.color = SKINCOLOR_DAMAGED
				g.scale = mo.sh.scale
				P_InstaThrust(g,mo.sh.angle,5*FRACUNIT)
				S_StartSound(mo.sh,mo.info.painsound)
				if mo.tracer and mo.tracer.valid
				and mo.tracer.player and mo.tracer.player.valid
					S_StartSound(mo.tracer,mo.info.painsound,mo.tracer.player)
				end
			end
			
			if not mo.health
			or not mo.shieldhealth
				P_KillMobj(mo.sh)
				mo.sh = nil
			end
			mo.hasshield = true
		else
			if mo.hasshield
				mo.flags = $&~MF_NOCLIPTHING
				mo.kaboom = TICRATE*3
			end
			local m = SearchForShootables(mo)
			if m and m.valid and m.health
			and mo.health
			and not mo.attach
				local maxspeed = 20*FRACUNIT
				if R_PointToDist2(mo.x,mo.y,m.x,m.y) > 50*FRACUNIT
					P_Thrust(mo,R_PointToAngle2(mo.x,mo.y,m.x,m.y),(maxspeed-R_PointToDist2(0,0,mo.momx,mo.momy))/4)
				else
					mo.target = m
					mo.attach = true
				end
			end
			mo.hasshield = false
			mo.kaboom = $ or 0
			if mo.attach and mo.target and mo.target.valid
			and mo.target.health
			and mo.health and mo.state != mo.info.deathstate
				if mo.kaboom
				and mo.kaboom > 25
					mo.kaboom = 25
				end
			
				local t = mo.target
				mo.state = S_BGUARD_STND
				local rx = P_ReturnThrustX(nil,t.angle,t.radius+mo.radius)
				local ry = P_ReturnThrustY(nil,t.angle,t.radius+mo.radius)
				P_ChangeOrigin(mo,t.x+rx,t.y+ry,t.z+t.height/2,true)
				mo.momx = t.momx
				mo.momy = t.momy
				mo.momz = t.momz
				mo.angle = R_PointToAngle2(mo.x,mo.y,t.x,t.y)
			end
			if mo.kaboom
				mo.kaboom = $-1
				mo.explode = true
			elseif mo.explode
				mo.explode = false
				local src = mo
				if mo.tracer and mo.tracer.valid
					src = mo.tracer
				end
				if mo.target and mo.target.valid
				and mo.target.health
					mo.attack = false
					P_DamageMobj(mo,nil,nil,1,DMG_INSTAKILL)
					P_Earthquake(mo.target,src,500*FRACUNIT)
					P_DamageMobj(mo.target,mo,src,1)
					mo.target = nil
				end
			end
		end
	end
end,MT_BUILDGUARD)
addHook("TouchSpecial", function(mo,mobj) --Damage fixes
	if mo and mo.valid
		if mobj and mobj.valid
		and mobj.player and mobj.player.valid
		and P_PlayerCanDamage(mobj.player,mo)
			if not mo.flashing
			and not CheckPlayer(mo.tracer, mobj)
				P_DamageMobj(mo,mobj,mobj,1)
				mo.flashing = 25
				mo.colorized = false
				mobj.momx = -$
				mobj.momy = -$
				mobj.momz = -$
			end
		end
		return true
	end
end, MT_BUILDGUARD)

local function Attacking(mo,mobj)
	if mo.player and mo.player.valid
		if mobj.tracer and mobj.tracer.valid
			if CheckPlayer(mobj,mo)
				return false
			else
				if P_PlayerCanDamage(mo.player,mobj)
					return true
				else
					return false
				end
			end
		end
	end
	
	if (mo.flags2 & MF2_JUSTATTACKED) --If object has attacked flag
		return true
	end
	return false
end
local function DoNotAffect(mo,mobj)
	if mo.tracer and mo.tracer.valid
		if mobj == mo.tracer
			return true
		end
			
		if (mobj.flags & MF_MISSILE)
		and mobj.target and mobj.target.valid
		and mobj.target == mo.tracer
			return true
		end
		if mobj.tracer and mobj.tracer.valid
		and mobj.tracer == mo.tracer
			return true
		end
		if CheckPlayer(mo.tracer,mobj)
			return true
		end
		if (mobj.flags & MF_MISSILE)
		and mobj.target and mobj.target.valid
		and CheckPlayer(mo.tracer,mobj.target)
			return true
		end
		if mobj.tracer and mobj.tracer.valid
		and CheckPlayer(mo.tracer,mobj.tracer)
			return true
		end
	end

	if mobj.player and mobj.player.valid
		if mo.tracer and mo.tracer.valid
		and CheckPlayer(mo,mobj)
			return true
		else
			return false
		end
	end
	return false
end

addHook("MobjMoveCollide", function(mo,mobj)
	if mo and mo.valid
	and mo.health
		if mobj and mobj.valid
		and mobj.health
		and mobj.flags & (MF_SHOOTABLE|MF_MISSILE)
			local thrustback = true
			if DoNotAffect(mo,mobj)
				thrustback = false
				return false
			end
			if not (mo.flags2 & MF2_FRET)
				if Attacking(mobj,mo) --Cancel attack!
					if mobj.type != MT_PLAYER
						mobj.state = mobj.info.spawnstate
						mobj.flags2 = $&~MF2_JUSTATTACKED
					end
				end
				local dodamage = true
				if mobj.type == MT_PLAYER
					if Attacking(mobj,mo)
						dodamage = true
					else
						dodamage = false
					end
				end
				if dodamage
					P_DamageMobj(mo,mobj,mobj)
				end
				if thrustback
					if not mo.stopthrust
						P_Thrust(mobj,mo.angle,R_PointToDist2(0,0,mobj.momx,mobj.momy)+15*FRACUNIT)
					end
					mo.stopthrust = 5
				end
			elseif thrustback
				P_InstaThrust(mobj,mo.angle,R_PointToDist2(0,0,mobj.momx,mobj.momy))
			end
		end
	end
end,MT_BUILDSHIELD)