//I need these to execute last.

addHook("ShouldDamage", function(mo,mobj,src,dmg,dmgtype) --Damage fixes for players
	if mo and mo.valid
		if mobj and mobj.valid
			if mobj.tracer and mobj.tracer.valid
			and mobj.tracer == mo
				return false
			end
			if CheckPlayer(mo,mobj)
				return false
			end
			if (mobj.flags & MF_MISSILE)
			and mobj.target and mobj.target.valid
			and CheckPlayer(mo,mobj.target)
				return false
			end
			if mobj.tracer and mobj.tracer.valid
			and CheckPlayer(mo,mobj.tracer)
				return false
			end
		end
	end
end,MT_PLAYER)

addHook("ShouldDamage", function(mo,mobj,src,dmg,dmgtype) --Damage fixes, they are kinda bad but should work.
	if mo and mo.valid
	and IsBuilding(mo)
		if mobj and mobj.valid
			if mo.tracer and mo.tracer.valid
				if mobj == mo.tracer
					return false
				end
			
				if (mobj.flags & MF_MISSILE)
				and mobj.target and mobj.target.valid
				and mobj.target == mo.tracer
					return false
				end
				if mobj.tracer and mobj.tracer.valid
				and mobj.tracer == mo.tracer
					return false
				end
				if CheckPlayer(mo.tracer,mobj)
					return false
				end
				if (mobj.flags & MF_MISSILE)
				and mobj.target and mobj.target.valid
				and CheckPlayer(mo.tracer,mobj.target)
					return false
				end
				if mobj.tracer and mobj.tracer.valid
				and CheckPlayer(mo.tracer,mobj.tracer)
					return false
				end
			end
		end
		if mo.type == MT_BUILDSENTRY
			mo.shootcd = TICRATE+25 --Hitting a sentry makes it not able to shoot for a while
		end
	end
end)
addHook("ShouldDamage", function(mo,mobj,src,dmg,dmgtype) --Cannot get hit by your own buildings.
	if mo and mo.valid
		if mobj and mobj.valid
		and IsBuilding(mobj)
		and mobj.tracer and mobj.tracer.valid
		and (mobj.tracer == mo or CheckPlayer(mobj.tracer,mo))
			return false
		end
	end
end, MT_PLAYER)
addHook("MobjDeath", function(mo,mobj,src,dmg,dmgtype) --Death hook so that variables reset properly and stuff happens how it should be
	if mo and mo.valid
	and IsBuilding(mo)
		if mo.type == MT_BUILDSHIELD
			local g = P_SpawnGhostMobj(mo)
			g.fuse = 10
			g.colorized = true
			g.color = SKINCOLOR_DAMAGED
			g.scale = mo.scale
			g.destscale = mo.scale/2*3
			
			local s = P_SpawnMobj(mo.x,mo.y,mo.z,MT_THOK)
			s.flags2 = $|MF2_DONTDRAW
			s.tics = TICRATE
			s.fuse = TICRATE
			S_StartSound(s,mo.info.deathsound)
			if mo.tracer and mo.tracer.valid
			and mo.tracer.player and mo.tracer.player.valid
				S_StartSound(mo.tracer,mo.info.deathsound,mo.tracer.player)
			end
		end
		
		mo.rollangle = 0
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		if mo.tracer and mo.tracer.valid
		and mo.tracer.player and mo.tracer.player.valid
			if mo.type == MT_BUILDSENTRY
				mo.tracer.player.builds.sentry = nil
			elseif mo.type == MT_BUILDSHIELD
				mo.tracer.player.builds.shield = nil
			elseif mo.type == MT_BUILDSPRING
				mo.tracer.player.builds.spring = nil
			end
		end
		
		/*local buildcost = { --I want to die
		[1] = 50,
		[2] = 35,
		[3] = 20}
		if IsBuilding(mo) == 2
		and mo.shieldhealth
			local co = ((35*FRACUNIT)/10*mo.shieldhealth)/FRACUNIT
			local rana = P_RandomRange(0,360)*ANG1
			for i = 1, co
				local fa = ((360/co)*i)*ANG1
				local r = P_SpawnMobjFromMobj(mo,0,0,mo.height,MT_SCRAPRING)
				r.fuse = TICRATE*4
				P_SetObjectMomZ(r,FRACUNIT*2)
				P_InstaThrust(r,fa,3*FRACUNIT)
			end
		end
		
		local timestuff = {
		[1] = 30,
		[3] = 15}
		if IsBuilding(mo) != 2
		and mo.runtime
			local bu = IsBuilding(mo)
			local t = timestuff[bu]
			local rt = mo.runtime/TICRATE
			local cost = buildcost[bu]
			local co = ((cost*FRACUNIT)/t*rt)/FRACUNIT
			local rana = P_RandomRange(0,360)*ANG1
			for i = 1, co
				local fa = ((360/co)*i)*ANG1
				local r = P_SpawnMobjFromMobj(mo,0,0,mo.height,MT_SCRAPRING)
				r.fuse = TICRATE*4
				P_SetObjectMomZ(r,FRACUNIT*2)
				P_InstaThrust(r,fa,3*FRACUNIT)
			end
		end*/
	end
end)

addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype) --Enemies drop scrap rings.
	if mo and mo.valid
		if mobj and mobj.valid
			mo.flashing = 25
			mo.colorized = false
			mobj.momx = -$
			mobj.momy = -$
			mobj.momz = -$
		end
	end
end,MT_BUILDSENTRY)

addHook("MobjDeath", function(mo,mobj,src,dmg,dmgtype) --Enemies drop scrap rings.
	if mo and mo.valid
	and not IsBuilding(mo)
	and mo.type != MT_PLAYER
	and ((mo.info.flags & (MF_ENEMY|MF_BOSS)) and (mo.info.flags & MF_SHOOTABLE))
	or (mo.info.flags & MF_SHOOTABLE)
		if not (mo.info.flags & (MF_MONITOR|MF_MISSILE))
			local co = mo.info.spawnhealth*10
			if co > 50
				co = 50
			end
			if mobj and mobj.valid
			or src and src.valid
				if src and src.valid and src.player and src.player.valid
					if src.player.rings
						src.player.rings = $+co
					else
						src.player.rings = co
					end
				elseif mobj and mobj.valid and mobj.player and mobj.player.valid
					if mobj.player.rings
						mobj.player.rings = $+co
					else
						mobj.player.rings = co
					end
				end
			end
		end
	end
end)